/*************************************************************************
						Takt berprfen

	MCU: tiny44	Takt:8MHz intern testweise auf 1MHz runtergeteilt
	Portbelegungen:
	Schleifen-Takt auf PA4
	Timer-Takt		auf PA5
*************************************************************************/
;
.nolist
.include "tn44def.inc"
.list

;***** Pins undTimerwert definieren
.equ takt1	= 4		;Pins,auf dem Takt ausgegeben wird
.equ takt2	= 5		;Takt vom Timer

;***** Global register variables
.def mp		= R16
.def temp1	= R17
.def temp2	= R18

.def data_eep	= R19
.def adr_H_eep	= R20
.def adr_L_eep	= R21
;
.CSEG
.org 0
;*** Interrupttabelle ***
	rjmp main			;Sprung zur Initialisierung
	reti					;INT0,ext.Interrupt
	reti					;PCINT0,PinChange-Interrupt PortA (Tasten 1-3)
	reti					;PCINT1,PinChange-Interrupt PortB
	reti					;Watchdog Timer Overflow
	reti					;Timer/Counter1 Capture Event
	reti					;Timer/Counter1 Compare Match A
	reti					;Timer/Counter1 Compare Match B
	reti					;Timer/Counter1 Overflow
	reti 					;Timer/Counter0 Compare Match A
	reti					;Timer/Counter0 Compare Match B
	rjmp takten					;Timer/Counter0 Overflow
	reti					;Analog Comparator
	reti					;ADC Convention Complete
	reti					;EEPROM Ready
	reti					;USI Start Condition
	reti					;USI Overflow
;
.include "tn44eeprom.inc"
;
/********************* ISP-Routinen **************************************
Versuch,genaue Frequenz von 0.1ms zu erzeugen (9600 Baud)
Takt wird auf PA5 ausgegeben
*/
takten:
	in		mp, SREG	
	push	mp

	in		mp,PORTA						;Pin toggle
	eor	mp,temp1
	out	PORTA,mp

	pop	mp
	out	SREG,mp
	reti

;
;******************** Unterprogramme *************************************


;******************** Hauptprogramm **************************************
main:
	ldi	mp,low(RAMEND)
	out	SPL,mp
	ldi	mp,high(RAMEND)
	out	SPH,mp
/*
;	ldi	mp,1<<clkps1				;Vorteiler auf 4 (Takt=8MHz/4=2MHz)
;	ldi	mp,1<<clkps0				;Vorteiler auf 2 (Takt=8MHz/=4MHz)
	ldi	mp,(1<<clkps1)|(1<<clkps0)	;Vorteiler auf 8 (Takt=8MHz/8=1MHz)
	ldi	temp1,(1<<clkpce)
	out	CLKPR,mp
	out	CLKPR,temp1					;Vorteilerbit setzen
*/
	ldi	adr_H_eep,0					;Calibrierungbyte holen
	ldi	adr_L_eep,$ff
	rcall	eeprom_read

	out	OSCCAL,data_eep			;und ins entsprechende Register bringen

;Timer0
	ldi	mp,(1<<CS01)|(1<<CS00)	;Prescaler 64 (8MHz/64=125kHz) 
	out	TCCR0B,mp

	ldi	mp,1<<TOIE0					;Timer0 Overflow
	out	TIMSK0,mp
;
;Ports
	sbi	DDRA,takt1					;Init port
	sbi	DDRA,takt2

	ldi	temp1,1<<takt2
	sei
;
/*** ein Zyklus = 8 Takte = 2s bei genau 4MHz Clock ***
Kontroll-Takt wird auf PA4 ausgegeben
*/
loop:

	sbi	PORTA,takt1					;2 Takte
	nop									;2*1 Takt
	nop
	cbi	PORTA,takt1					;2*2 Takte

	rjmp	loop
;
.exit


